dub1   move.l  d3,-(a7)       ; push reg
       lea.l   datac,a5
       move.b  (a5),d3 
       addq.w  #1,d2          ; plus one for loop
       neg.w   d2             ; negate # of bytes for index

; scan thro bytes transfered from ipq to memory

db1    addq.w  #1,d2          ; scan thro bytes in ipq
       beq     db8            ; finished if zero
       tst.b   0(a1,d2.w)     ; is it a status byte
       bpl     db5            ; no ? skip
       move.b  0(a1,d2.w),d0
       andi.b  #$f0,d0
       cmpi.b  #$f0,d0        ; yes ? then is it a sys. byte
       beq     db3            ; yes ? then skip

; it is a status byte but not a system byte

       lea.l   csb,a5         ; get current status byte address
       move.b  0(a1,d2.w),(a5) ; store new current status byte 
       cmpi.b  #1,d3          ; check for one data byte
       bne     db7            ; no ? skip and set delays etc

; it is a status byte and previous data byte count was only one

       move.w  d2,d1          ; yes ? copy index
       not.w   d1             ; complement to make pos and one less
       addq.w  #1,d1          ; include last data byte in shuffle
       clr.w   d2             ; zero index
db2    move.b  -1(a1,d2.w),0(a1,d2.w)
       subq.w  #1,d2
       dbf     d1,db2         ; shuffle bytes
       adda.l  #1,a1          ; inc address
       addq.w  #1,d2
       bra     db7            ; skip and set delays etc

; it is a status byte and a system byte so remove it    

db3    move.w  d2,d1          ; yes ? copy index
       not.w   d1             ; complement to make pos and one less
       move.w  d2,-(a7)       ; save index
;
db4    move.b  1(a1,d2.w),0(a1,d2.w)
       addq.w  #1,d2          ; 
       dbf     d1,db4         ; shuffle bytes
       move.w  (a7)+,d2       ; restore index
       suba.l  #1,a1          ; adjust event pointer
       bra     db1            ; check the rest

; it is a data byte

db5    addq.b  #1,d3          ; inc data byte count
       cmpi.b  #3,d3          ; is it third consecutive data byte
       bne.s   db1            ; no ? then get next

; it is a data byte and the third in a row so insert status byte

       move.w  d2,d1          ; yes ? copy index
       not.w   d1             ; complement to make pos and one less
       clr.w   d2             ; zero index
db6    move.b  -1(a1,d2.w),0(a1,d2.w)
       subq.w  #1,d2
       dbf     d1,db6         ; shuffle bytes
       lea.l   csb,a5         ; copy current status byte
       move.b  (a5),0(a1,d2.w)
       adda.l  #1,a1          ; inc address
       move.b  #1,d3
       bra.s   db9

; and set delays etc

db7    moveq   #0,d3          ; zero data byte count
db9    move.w  d6,(a2)+       ; store rcv delay cnt
       clr.l   d6             ; clear rcv delay cnt
       addq.w  #1,(a0)        ; inc # events
       bra     db1            ; check the rest

db8    lea.l  datac,a5
       move.b d3,(a5) 
       move.l (a7)+,d3        ; restore reg

