*********************************************************
*              file name : TRACKER_ASM                  *
*********************************************************
*
s_top  equ     $73            * key "s"
yes    equ     $aa            * confirmation codes from
no     equ     $55            * MIDI for status enquiries
*
* these are the codes for MIDI interface operations
*
do_rcv equ     $80            * tell interface to receive
do_snd equ     $40            * tell interface to transmit
tst_in equ     $20            * any data in ip Q?
tst_ot equ     $10            * any space in op Q
*
       move.w  $110,a0
       lea.l   procs,a1
       jsr     (a0)
       rts
*
procs  dc.w    5
*
       dc.w    setup-*
       dc.b    6
       dc.b    'm_init'
*
       dc.w    do_tx-*
       dc.b    6
       dc.b    'm_send'
*
       dc.w    do_rx-*
       dc.b    6
       dc.b    'm_recv'
*
       dc.w    do_pla-*
       dc.b    6
       dc.b    'm_play'
*
        dc.w   do_rec-*
        dc.b   6
        dc.b   'm_recd'
*
        dc.w   0
        dc.w   0
        dc.w   0
*
do_tx  move.w  $118,a0
       jsr     (a0)
       bne     texit
       moveq   #-15,d0
       cmpi.w  #2,d3
       bne     texit
       move.l  0(a6,a1.l),a4   * start of block in a1
       move.l  4(a6,a1.l),d2   * length in d2
       move.l  a1,-(a7)
       movea.l a4,a1
       trap    #0
       ori.w   #$0700,sr
       bsr     transm         * send the data block
       andi.w  #$d8ff,sr
       move.l  (a7)+,a1
texit  rts
*
do_rx  move.w $118,a0
       jsr     (a0)
       bne     gexit
       moveq   #-15,d0
       cmpi.w  #2,d3
       bne     gexit
       move.l  0(a6,a1.l),a4   * start of block in a1
       move.l  4(a6,a1.l),d6   * # of bytes to get in d6
       move.l  a1,-(a7)
       movea.l a4,a1
*
       movem.l d1/d3-d4/a0-a1,-(a7) * push registers
       bsr     rx                   * clear ipq
       movem.l (a7)+,d1/d3-d4/a0-a1 * pop registers
*
       tst.l   d0
       bne     gerr
*  
rx_lp  bsr     rx
       tst.l   d0
       bne     gerr
       sub.w   d2,d6
       bhi.s   rx_lp
*
gerr   move.l  (a7)+,a1
gexit  rts
*
rx     trap    #0             *
       ori.w   #$0700,sr      * receive
       bsr     receiv         *
       andi.w  #$d8ff,sr      *
       rts 
*
tx     trap    #0             *
       ori.w   #$0700,sr      * transmit
       bsr     transm         *
       andi.w  #$d8ff,sr      *
       rts 
*
do_pla move.w  $118,a0
       jsr     (a0)
       bne     pexit
       moveq   #-15,d0
       cmpi.w  #10,d3
       bne     pexit
       move.l  0(a6,a1.l),d1   * get click flag
       move.l  4(a6,a1.l),d2   * # events on track2
       move.l  8(a6,a1.l),d3   * intro
       move.l  12(a6,a1.l),d4  * # of loops/tick
       move.l  16(a6,a1.l),d5  * # ticks/beat
       move.l  20(a6,a1.l),a0  * # events, dummy for play
       move.l  24(a6,a1.l),a5  * ptr to event buffer 1
       move.l  28(a6,a1.l),a2  * ptr to delay buffer 1
       move.l  32(a6,a1.l),a3  * ptr to event buffer 2
       move.l  36(a6,a1.l),a4  * ptr to delay buffer 2
       clr.l   d6
       move.l  a1,-(a7)
       movea.l a5,a1
       bsr     play
       move.l  (a7)+,a1
pexit  rts
*    *     *     *
play   lea.l   cflag,a5
       move.w  d1,(a5)        * store click flag
       lea.l   evno,a5
       move.w  d2,(a5)        * store # events on track 2
       lea.l   lpt,a5
       move.w  d4,(a5)        * store # loops/tick
       lea.l   tpb,a5
       move.w  d5,(a5)        * store # ticks/beat
*
       movem.l d1/d3-d4/a0,-(a7)
       bsr     rx                 * clear ipq
       movem.l (a7)+,d1/d3-d4/a0
*
       tst.l   d0             * check for error
       bne     err1
*
       movem.l d1/d3-d4/a0,-(a7) *   push registers
rec    bsr     rx                *   get data byte from midi
       movem.l (a7)+,d1/d3-d4/a0 *   pop registers
*
       tst.l   d0             *   if interface has crashed
       bne     err1           *     exit recording
*                             *   else
       tst.w   d2             *   how many bytes did we receive
       beq.s   rec2           *   none ?  then try again
*
       movem.l d1-d4/a0-a1,-(a7)     * push registers
       suba.l  d2,a1                 * set address right for transmit
       bsr     tx                    * transmit contents of ipq
       movem.l (a7)+,d1-d4/a0-a1     * pop registers
*
       tst.l   d0
       bne     err1
       suba.l  d2,a1          *   reset event buff to start
       bra.s   rec2           *   and go again
*
rec1   addq.w  #1,d2          * plus one for loop
       neg.w   d2             * negate # of bytes for index
rc     addq.w  #1,d2          * scan thro bytes in ipq
       beq.s   rec2           * finished if zero
       tst.b   0(a1,d2.w)     * is it a status byte
       bpl.s   rc             * no ? check the rest
       move.l  d6,(a2)+       * yes ? store clock cnt
       addq.w  #1,(a0)        * inc # events
       bra.s   rc             * check the rest
*
rec2   dbra    d4,rec10       * dec # loops/tick go not zero
       lea.l   lpt,a5
       move.w  (a5),d4        * re_init # loops/tick
       tst.w   d3             * is intro finished
       bne.s   rec8           * no then skip delay inc etc
*
       movem.l d1-d4/a0-a1,-(a7)   * push registers
       move.w  #1,d2               * single byte to transmit
       lea.l  clock,a1             * send clock byte
       bsr     tx                  * transmit byte
       movem.l (a7)+,d1-d4/a0-a1   * pop registers
*
       lea.l   evno,a5        *
       tst.w   (a5)           * check num events on track 2
       beq.s   rec7           * if zero then skip transmit
       cmp.l   (a4),d6        * has clock cnt reached track2 cnt
       blt.s   rec7           * no ? then skip transmit
*
rec3   move.w  #2,d2          * three bytes to store
rec4   move.b  (a3)+,(a1)+    * from pre_rec ev buff to ev buff
       dbra    d2,rec4        * do it
       move.w  #3,d2          * three bytes to transmit
*
       suba.l  #3,a1
       movem.l d1-d4/a0-a1,-(a7)   * push registers
       bsr     tx                  * transmit event from pre_rec track
       movem.l (a7)+,d1-d4/a0-a1   * pop registers
*
       tst.l   d0
       bne   err1
       move.w  d6,(a2)        * store delay count no inc for play
       addq.w  #1,(a0)        * dummy for play
* 
       lea.l   evno,a5
       subq.w  #1,(a5)        * dec # events on track2
       tst.w   (a5)           *
       beq.s   ret_ok         * go if zero
*
       adda.l  #4,a4          * get next count
       cmp.l   (a4),d6        *
       beq.s   rec3           * if same get next event
*
rec7   addq.w  #1,d6          * inc delay count
rec8   dbra    d5,rec10       * dec # midi ticks/beat go not zero
       lea.l   tpb,a5         *
       move.w  (a5),d5        * re_init midi ticks/beat
*
       bsr     keys           * scan keys for 's' stop
       cmp.b   #8,d1
       beq.s   ret_ok
*
       lea.l   cflag,a5       *
       tst.w   (a5)           * test click flag
       beq.s   rec9           * if zero skip click
       bsr     click          * sound metronome click
*
rec9   tst.w   d3             * is intro finished
       beq.s   rec10          * yes ? skip
       subq.w  #1,d3          * no ?  then dec intro
*
       tst.w   d3             * is intro finished
       bne.s   rec10          * no ? then skip
*
       movem.l d1-d4/a0-a1,-(a7)   * push registers
       move.w  #1,d2               * single byte to transmit
       lea.l   start,a1            * send start byte
       bsr     tx                  * transmit byte
       movem.l (a7)+,d1-d4/a0-a1   * pop registers
*

rec10  movem.l d1/d3-d4/a0,-(a7)
       bra     rec
*
ret_ok movem.l d1-d4/a0-a1,-(a7)   * push registers
       move.w  #1,d2               * single byte to transmit
       lea.l  last,a1              * send stop byte
       bsr     tx                  * transmit byte
       movem.l (a7)+,d1-d4/a0-a1   * pop registers
*
       clr.l   d0             * no error for QDOS
err1   rts
*
do_rec move.w  $118,a0
       jsr     (a0)
       bne     rexit
       moveq   #-15,d0
       cmpi.w  #10,d3
       bne    rexit
       move.l  0(a6,a1.l),d1   * get click flag
       move.l  4(a6,a1.l),d2   * # events on track2
       move.l  8(a6,a1.l),d3   * intro
       move.l  12(a6,a1.l),d4  * # of loops/tick
       move.l  16(a6,a1.l),d5  * # ticks/beat
       move.l  20(a6,a1.l),a0  * # events, dummy for play
       move.l  24(a6,a1.l),a5  * ptr to event buffer 1
       move.l  28(a6,a1.l),a2  * ptr to delay buffer 1
       move.l  32(a6,a1.l),a3  * ptr to event buffer 2
       move.l  36(a6,a1.l),a4  * ptr to delay buffer 2
       clr.l   d6
       move.l  a1,-(a7)
       movea.l a5,a1
       bsr     record
       move.l  (a7)+,a1
rexit  rts
***********************       **************************
record move.l  a1,-(a7)       * save address of event buff 1
       lea.l   cflag,a5
       move.w  d1,(a5)        * store click flag
       lea.l   evno,a5
       move.w  d2,(a5)        * store # events on track 2
       lea.l   lpt,a5
       move.w  d4,(a5)        * store # loops/tick
       lea.l   tpb,a5
       move.w  d5,(a5)        * store # ticks/beat

* 
       movem.l d1/d3-d4/a0-a1,-(a7) * push registers
       bsr     rx                   * clear ipq
       movem.l (a7)+,d1/d3-d4/a0-a1 * pop registers
*
       tst.l   d0
       bne     err2
*
       movem.l d1/d3-d4/a0,-(a7) *   push registers
dub    bsr     rx                *   get data byte from midi
       movem.l (a7)+,d1/d3-d4/a0 *   pop registers
*
       tst.l   d0             *   if interface has crashed
       bne     err2           *     exit recording
*                             *   else
       tst.w   d2             *   how many bytes did we receive
       beq     dub2           *   none ?  then try again
*
       movem.l d1-d4/a0-a1,-(a7)     * push registers
       suba.l  d2,a1                 * set address right for transmit
       bsr     tx                    * transmit contents of ipq
       movem.l (a7)+,d1-d4/a0-a1     * pop registers
*
       tst.l   d0
       bne     err2
       tst.w   d3             *   is intro finished
       beq.s   dub1           *   yes then skip
       suba.l  d2,a1          *   no then reset event buff to start
       bra     dub2           *   and try again
*
dub1   move.l  d3,-(a7)       * push reg
       lea.l   datac,a5
       move.b  (a5),d3 
       addq.w  #1,d2          * plus one for loop
       neg.w   d2             * negate # of bytes for index
*
* scan thro bytes transfered from ipq to memory
*
db1    addq.w  #1,d2          * scan thro bytes in ipq
       beq     db8            * finished if zero
       tst.b   0(a1,d2.w)     * is it a status byte
       bpl     db5            * no ? skip
       move.b  0(a1,d2.w),d0
       andi.b  #$f0,d0
       cmpi.b  #$f0,d0        * yes ? then is it a sys. byte
       beq     db3            * yes ? then skip
*
* it is a status byte but not a system byte
*
       lea.l   csb,a5         * get current status byte address
       move.b  0(a1,d2.w),(a5) * store new current status byte 
       cmpi.b  #1,d3          * check for one data byte
       bne     db7            * no ? skip and set delays etc
*
* it is a status byte and previous data byte count was only one
*
       move.w  d2,d1          * yes ? copy index
       not.w   d1             * complement to make pos and one less
       addq.w  #1,d1          * include last data byte in shuffle
       clr.w   d2             * zero index
db2    move.b  -1(a1,d2.w),0(a1,d2.w)
       subq.w  #1,d2
       dbf     d1,db2         * shuffle bytes
       adda.l  #1,a1          * inc address
       addq.w  #1,d2
       bra     db7            * skip and set delays etc
*
* it is a status byte and a system byte so remove it    
*
db3    move.w  d2,d1          * yes ? copy index
       not.w   d1             * complement to make pos and one less
       move.w  d2,-(a7)       * save index
*
db4    move.b  1(a1,d2.w),0(a1,d2.w)
       addq.w  #1,d2          * 
       dbf     d1,db4        * shuffle bytes
       move.w  (a7)+,d2       * restore index
       suba.l  #1,a1          * adjust event pointer
       bra     db1            * check the rest
*
* it is a data byte
*
db5    addq.b  #1,d3          * inc data byte count
       cmpi.b  #3,d3          * is it third consecutive data byte
       bne.s   db1            * no ? then get next
*
* it is a data byte and the third in a row so insert status byte
*
       move.w  d2,d1          * yes ? copy index
       not.w   d1             * complement to make pos and one less
       clr.w   d2             * zero index
db6    move.b  -1(a1,d2.w),0(a1,d2.w)
       subq.w  #1,d2
       dbf     d1,db6         * shuffle bytes
       lea.l   csb,a5         * copy current status byte
       move.b  (a5),0(a1,d2.w)
       adda.l  #1,a1          * inc address
       move.b  #1,d3
       bra.s   db9
*
* and set delays etc
*
db7    moveq   #0,d3          * zero data byte count
db9    move.l  d6,(a2)+       * store track 1 clock cnt
       addq.w  #1,(a0)        * inc # events
       bra     db1            * check the rest
*
db8 lea.l  datac,a5
    move.b d3,(a5) 
    move.l (a7)+,d3        * restore reg
*        
dub2   dbra    d4,dub10       * dec # loops/tick go not zero
       lea.l   lpt,a5
       move.w  (a5),d4        * re_init # loops/tick
       tst.w   d3             * is intro finished
       bne.s   dub8           * no then skip delay inc etc
*
       movem.l d1-d4/a0-a1,-(a7)   * push registers
       move.w  #1,d2               * single byte to transmit
       lea.l  clock,a1             * send clock byte
       bsr     tx                  * transmit byte
       movem.l (a7)+,d1-d4/a0-a1   * pop registers
*
       lea.l   evno,a5        *
       tst.w   (a5)           * check num events on track 2
       beq.s   dub7           * if none skip transmit
       cmp.l   (a4),d6        * has current cnt yet reached track 2 cnt
       blt.s   dub7           * no ? then skip transmit
*
dub3   move.w  #2,d2          * three bytes to store
dub4   move.b  (a3)+,(a1)+    * from pre_rec ev buff to ev buff
       dbra    d2,dub4        * do it
       move.w  #3,d2          * three bytes to transmit
*        
       movem.l d1-d4/a0-a1,-(a7)   * push registers
       suba.l  #3,a1               * set ev buff for transmit
       bsr     tx                  * transmit event from pre_rec track
       movem.l (a7)+,d1-d4/a0-a1   * pop registers
*
       tst.l   d0
       bne     err2
*
       move.l  d6,(a2)+       * store clock cnt
       addq.w  #1,(a0)        * inc # events
* 
       lea.l   evno,a5
       subq.w  #1,(a5)        * dec # events on track2
       tst.w   (a5)           *
       beq.s   dub7           * go if zero
*
       adda    #4,a4          * inc track 2 count pointer
       cmp.l   (a4),d6
       beq.s   dub3           * if next delay is zero get next event
*
dub7   addq.l  #1,d6          * inc clock count
dub8   dbra    d5,dub10       * dec # midi ticks/beat go not zero
       lea.l   tpb,a5         *
       move.w  (a5),d5        * re_init midi ticks/beat
*
       bsr     keys           * scan keys for 's' stop
       cmp.b   #8,d1
       beq.s   ok_ret
*
       lea.l   cflag,a5      
       tst.w   (a5)           * test click flag
       beq.s   dub9           * if zero skip click
       bsr     click          * sound metronome click
*
dub9   tst.w   d3             * is intro finished
       beq.s   dub10          * yes ? skip
       subq.w  #1,d3          * no ?  then dec intro
*
       tst.w   d3             * is intro finished
       bne.s   dub10          * no ? then skip
*
       movem.l d1-d4/a0-a1,-(a7)   * push registers
       move.w  #1,d2               * single byte to transmit
       lea.l   start,a1            * send start byte
       bsr     tx                  * transmit byte
       movem.l (a7)+,d1-d4/a0-a1   * pop registers
*
dub10  movem.l d1/d3-d4/a0,-(a7)
       bra     dub
*
ok_ret movem.l d1-d4/a0-a1,-(a7)   * push registers
       move.w  #1,d2               * single byte to transmit
       lea.l  last,a1              * send stop byte
       bsr     tx                  * transmit byte
       movem.l (a7)+,d1-d4/a0-a1   * pop registers
*
       move.l  d6,(a2)+       * store final delay
       lea.l   evno,a5        * get # events track 2
       move.l  (a7)+,a1       * get ev(1)
       move.w  (a5),-2(a1)    * return # events track 2
       clr.l   d0             * no error for QDOS
err2   rts
*
click  movem.l d1-d7/a0-a5,-(a7)
       lea     ip1cmd,a3
       moveq   #17,d0
       trap    #1
       movem.l (a7)+,d1-d7/a0-a5
       rts
* 
ip1cmd
       dc.b    10,8,0,0,170,170,1,0,0,0,160,0,0,0,1
       cnop    0,4
* 
keys   movem.l d2-d7/a0-a5,-(a7)
       lea     ip2cmd,a3
       moveq   #17,d0
       trap    #1
       movem.l (a7)+,d2-d7/a0-a5
       rts
* 
ip2cmd
       dc.b    09,01,00,00,00,00,03,02
       cnop    0,4
* 
cflag  dc.w    0
evno   dc.w    0
lpt    dc.w    0
tpb    dc.w    0
*
* This subroutine sends bytes to the MIDI
* A1 points to the base of the data to send
* and D2.W the number of bytes
*
transm moveq   #tst_ot,d0     * first test the
       bsr     status         * status of the op Q
       tst.l   d0             * check for error
       beq.s   tran_1         * and jump if ok
       rts                    * report failure
*
* The branch will be taken, if the MIDI responds, with
* D1.W holding the amount of free space in the op Q
*
tran_1 tst.w   d1             * if no space in op Q
       beq.s   transm         * then try again
       cmp.w   blksiz,d2      * is it too big for 1 go
       ble.s   lastbk         * jump if not
       move.w  blksiz,d0      * so use max size possible
       bra.s   sendit         * jump forward to send block
lastbk move.w  d2,d0          * use last few bytes
sendit cmp.w   d0,d1          * is there room in MIDI?
       bgt.s   outblk         * jump if yes
       move.w  d1,d0          * enough to fill MIDI
outblk sub.w   d0,d2          * reduce byte count
       bsr     txblok         * send to MIDI
       tst.w   d2             * any bytes left to send?
       bne     transm         * back if yes
       moveq   #0,d0          * no error
       rts                    * return
* This subroutine does the transfer of bytes from the
* QL to the MIDI interface and is time critical
*
* Enter with D0.W holding number of bytes to send and
* A1 pointing to location of start of data block
*
txblok move.b  do_rcv(a0),d3  * send the command
*
* Wait for MIDI to take notice
*
       move.w  txdly1,d3      * get timing constant
txwt1  dbf     d3,txwt1       * wait 224/4 us
       andi.w  #$00ff,d0      * make it word sized
       move.b  0(a0,d0.w),d3  * send number of bytes
*
* Wait for MIDI to prepare itself to receive
*
       move.w  txdly2,d3      * fetch timing constant
txwt2  dbf     d3,txwt2       * wait 92/4 us
       subq.w  #1,d0          * adjust for DBF
putdat clr.l   d3             * waste some time
       move.b  (a1)+,d3       * get the byte to send
       move.b  0(a0,d3.w),d3  * send it to the MIDI
       dbf     d0,putdat      * do for all bytes
       rts                    * all done
*
* Subroutine to receive bytes from MIDI interface
* A1 should point to the area to fill
* D2.W returns the number of bytes received
* A1 points to last location filled + 1
*
receiv moveq   #0,d2          * initialise byte counter
nxtblk moveq   #tst_in,d0     * test status of
       bsr     status         * the ip Q
       tst.l   d0             * error?
       beq.s   rcv_1          * jump if ok else
empty  rts                    * report the error
*
* Execution will continue here if the MIDI responds
* With D1.W holding the amount of data in the ip Q
*
rcv_1  tst.w   d1             * is any data pending?
       beq.s   empty          * quit if MIDI empty
       cmp.w   blksiz,d1
       ble.s   allblk
       move.w  blksiz,d0
       bra.s   getit
allblk move.w  d1,d0
getit  add.w   d0,d2
       bsr     rxblok
       bra     nxtblk
* The following subroutine deals with the transfer of
* bytes from the MIDI interface to the QL and is time
* critical
*
* Enter with D0.W holding number of bytes to receive and
* A1 pointing to storage space
*
rxblok move.b  do_snd(a0),d3  * tell MIDI the operation
*
* Wait for the command to be recognised
*
       move.w  rxdly1,d3      * get timing constant
rxwt1  dbf     d3,rxwt1       * wait 210/4 us
       andi.w  #$00ff,d0      * d0 must be word sized
       move.b  0(a0,d0.w),d3  * say how many bytes
*
* wait for MIDI to do its sums
*
       move.w  rxdly2,d3      * pick up constant
rxwt2  dbf     d3,rxwt2       * wait 92/4 us
       subq.w  #1,d0
getdat move.b  (a0),(a1)+     * get byte and store it
       clr.l   d3
       asr.l   #3,d3
       dbf     d0,getdat
       clr.l   d0
       rts
*
* Subroutine to test the status of the MIDI interface
* and is time critical.
* D0.B determines the operation to be performed
*  TST_OT  D0.B=$10  is op Q full?
*  TST_IN  D0.B=$20  is ip Q empty?
*
* On return D1.W holds the number of bytes
* for TST_IN D1.W is the amount of data in ip Q
* for TST_OT D1.W holds amount of space in op Q
* also note that A0.L=$0000C000 the address of the
* MIDI port which is not loaded in any other routine
*
* Only one possible error can occur which is if the
* MIDI has crashed and reported as 'interface crashed'
* via a user defined message
*
status movea.l #$0000C000,a0  * MIDI port address
       moveq   #0,d1          * no room/data default
       move.b  0(a0,d0.w),d0  * ask the question
*
* Wait for MIDI to respond
*
       move.w  stdly,d3       * get timing constant
stwait dbf     d3,stwait      * wait 286/4 us
       move.b  (a0),d0        * get the reply
       cmp.b   #yes,d0        * if empty/full d0 is
       beq.s   st_ok          * cleared then exit
       cmp.b   #no,d0         * if not empty/full the
       beq.s   getsiz         * byte count is required
       lea     crash,a0       * invalid reply is error
       bra     reperr         * report
getsiz move.w  #8,d4          * wait 56/4 us for MIDI to
       asr.l   d4,d3          * do its sums
       move.b  (a0),d1        * get size from MIDI
       bne.s   st_ok          * quit with valid size
       move.w  #$0100,d1      * else size must be 256
st_ok  moveq   #0,d0          * no error
       rts                    * all done
* This subroutine tests the RAM in which the code is
* resident and sets up the timing constant table
* depending on the number of wait states being used
*
setup  moveq   #0,d3          * initialise sum
       moveq   #2,d4          * three repetitions
averag moveq   #$13,d0        * find the start time
       trap    #1             * read clock
       move.l  d1,-(a7)       * save start time
       bsr     memtst         * test the memory
       moveq   #$13,d0        * find the finish time
       trap    #1             * read the clock
       move.l  (a7)+,d0       * restore the start time
       sub.l   d0,d1          * calculate elapsed time
       subq.l  #5,d1          * min time of routine
       add.b   d1,d3          * add to total
       dbf     d4,averag      * do again
       addq.b  #1,d3          * get best of 3 wait state
       divu    #3,d3          * measurements
       cmp.b   #3,d3          * over 3 is too slow
       bls.s   mem_ok         * jump if fast enough
       lea     memslo,a0      * else its no good
reperr move.l  #-19,d0         * pass error address to D0
       rts                    * report it
mem_ok mulu    #12,d3         * table is 12 bytes long
       lea     timtab,a0      * point to constants
       lea     0(a0,d3.w),a0  * index in
       lea     blksiz,a1      * point to storage
       moveq   #5,d0          * 6 parameters to copy
filtab move.w  (a0)+,(a1)+    * copy them over
       dbf     d0,filtab      * until finished
       moveq   #0,d0          * all ok
       rts                    * all done
*
* This routine is used to determine how fast the RAM is.
* The routine takes 5 seconds plus 1 sec per wait state
*
memtst trap    #0             * into supervisor mode
       ori.w   #$0700,sr      * QDOS interrupts off
       move.l  #425000,d0     * timing constant
       lea     blksiz,a0      * use temp location
test   move.l  (a0),(a0)      * waste time
       asr.l   #4,d1          * waste time again
       subq.l  #1,d0          * reduce counter
       bne.s   test           * until finished
       andi.w  #$d8ff,sr      * user mode again
       rts                    * back again
       cnop    0,4
*
blksiz ds.w    1              * depends on speed of RAM
stdly  ds.w    1              * these locations hold
txdly1 ds.w    1              * constants which are set
txdly2 ds.w    1              * up according to the
rxdly1 ds.w    1              * speed of RAM and are used
rxdly2 ds.w    1              * for timing purposes
*
* The following table holds delay constants for RAM
* running at different wait states.  The setup routine
* copies the corresponding data into the above table to
* be used in the running program
*
       cnop    0,4
timtab dc.w    4,37,31,9,29,9    * zero wait states
       dc.w    3,30,25,7,24,7    * one
       dc.w    2,25,21,6,20,6    * two
       dc.w    1,22,18,5,17,5    * three
*
start  dc.b    %11111010
       cnop    0,4 
clock  dc.b    %11111000
       cnop    0,4
last   dc.b    %11111100
csb    dc.b    0
datac  dc.b    0
       cnop    0,4
*
* Error messages
*
memslo dc.w    16
       dc.b    'memory too slow',10
       cnop    0,4
crash  dc.w    18
       dc.b    'interface crashed',10
*
       end
